/*
 * The Cryptonit security software suite is developped by IDEALX
 * Cryptonit Team (http://IDEALX.org/ and http://cryptonit.org).
 *
 * Copyright ? 2004 IDEALX
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301, USA. 
 *
 * In addition, as two special exceptions:
 *
 * 1) IDEALX S.A.S gives permission to:
 *  * link the code of portions of his program with the OpenSSL library under
 *    certain conditions described in each source file
 *  * distribute linked combinations including the two, with respect to the
 *    OpenSSL license and with the GPL
 *
 * You must obey the GNU General Public License in all respects for all of the
 * code used other than OpenSSL. If you modify file(s) with this exception,
 * you may extend this exception to your version of the file(s), but you are
 * not obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version, in all files (this very one along with all
 * source files).

 * 2) IDEALX S.A.S acknowledges that portions of his sourcecode uses (by the
 * way of headers inclusion) some work published by 'RSA Security Inc.'. Those
 * portions are "derived from the RSA Security Inc. PKCS #11Cryptographic
 * Token Interface (Cryptoki)" as described in each individual source file.
 */
#include "P11Devices.hh"

#include "P11USBDevices.hh"

namespace Cryptonit
{
    P11Devices::P11Devices()
    {
    }


    P11Devices::~P11Devices()
    {
    }


    int P11Devices::autodetect()
    {
	std::vector<P11Device> myDevices;

	/* Detecting USB PKCS11 devices */
	int ret = getUSBDevices( myDevices );

	if( ret > 0 ) {
	    /* Copy the contents the deteted devices to 'devices' */
	    std::vector<P11Device>::iterator i;
	    for( i = myDevices.begin(); i != myDevices.end(); i++ )
		devices.push_back(*i);
	}
	return ret;

    }


    std::vector<std::string> P11Devices::getDevicesProductName()
    {
	std::vector<std::string> nameList;
	std::vector<P11Device>::iterator i;

	for( i = devices.begin(); i != devices.end(); i++ )
	    nameList.push_back( i->getProduct() );

	return nameList;
    }


    std::vector<std::string> P11Devices::getDetectedDriverList()
    {
	std::vector<std::string> driverList;
	std::vector<P11Device>::iterator i;

	for( i = devices.begin(); i != devices.end(); i++ )
	    driverList.push_back( i->getDriverFilename() );

	return driverList;
    }

};

